您的位置:首页 > 其它

hdu 1695 GCD (欧拉函数、容斥原理)

2015-08-06 19:21 519 查看


GCD

Time Limit: 6000/3000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)

Total Submission(s): 7357 Accepted Submission(s): 2698



Problem Description

Given 5 integers: a, b, c, d, k, you're to find x in a...b, y in c...d that GCD(x, y) = k. GCD(x, y) means the greatest common divisor of x and y. Since the number of choices may be very large, you're only required to output the total number of different number
pairs.

Please notice that, (x=5, y=7) and (x=7, y=5) are considered to be the same.

Yoiu can assume that a = c = 1 in all test cases.

Input

The input consists of several test cases. The first line of the input is the number of the cases. There are no more than 3,000 cases.

Each case contains five integers: a, b, c, d, k, 0 < a <= b <= 100,000, 0 < c <= d <= 100,000, 0 <= k <= 100,000, as described above.

Output

For each test case, print the number of choices. Use the format in the example.

Sample Input

2
1 3 1 5 1
1 11014 1 14409 9


Sample Output

Case 1: 9
Case 2: 736427

HintFor the first sample input, all the 9 pairs of numbers are (1, 1), (1, 2), (1, 3), (1, 4), (1, 5), (2, 3), (2, 5), (3, 4), (3, 5).


Source

2008 “Sunline Cup” National Invitational Contest

题目大意:求出[a,b]和[c,d]区间里面gcd(x,y)=k的数的对数。

思路:既然是求gcd为k的数的对数,不妨先将b和d都除以k,这样问题就转化为[1,n]和[1,m]区间里面gcd(x,y)为1 的数的对数。因为题目里已经说明a和c 可以认为是1,这样就更简单了。对于一个[1,n]的区间,我们可以用欧拉函数算出总对数。

那么问题就可以分解成2个:

1、在[1,n]上用欧拉函数算出总对数。

2、在[n+1,m]上,计算在[1,n]里面的总对数,可以用容斥原理。

#include<stdio.h>
#include<math.h>
#include<string.h>
#include<iostream>
#include<algorithm>
#include<vector>
#define min(a,b) a<b?a:b
#define max(a,b)  a>b?a:b
#define Max 100005
#define LL __int64
using namespace std;
LL sum[Max],tot;
int p[Max][20];
int num[Max];
void init()
{
sum[1]=1;
for(int i=2;i<Max;i++)
sum[i]=i;
for(int i=2;i<Max;i++)
if(sum[i]==i)
for(int j=i;j<Max;j+=i)
sum[j]=sum[j]/i*(i-1);

}
void init2()
{
LL x,k,i,j;
for( i=1;i<=Max;i++)
{
x=i;k=0;
for(j=2;j<=sqrt(i);j++)
{
if(x%j==0){
while(x%j==0)x=x/j;
//	p[i].push_back(j);
p[i][num[i]++]=j;
}
}
if(x>1)p[i][num[i]++]=x;
}
}
LL dfs(int n,int b,int x,int k)
{
LL ans=0;
for(int i=x;i<k;i++)
{
ans+=b/p
[i]-dfs(n,b/p
[i],i+1,k);
}
return ans;
}
int main()
{
LL T,a,b,c,d,k;
int i,j,t;
init();
init2();
//	printf("%I64d %I64d\n",sum[2],sum[3]);
scanf("%I64d",&T);
t=0;
while(T--)
{
tot=0;
t++;
scanf("%I64d%I64d%I64d%I64d%I64d",&a,&b,&c,&d,&k);
printf("Case %d: ",t);
if(k==0){printf("0\n");continue;}
b=b/k;
d=d/k;
int m;
m=min(b,d);
d=max(b,d);
b=m;
for(i=1;i<=b;i++)
tot=tot+sum[i];
for(i=b+1;i<=d;i++)
{
//  printf("%d\n",p[i].size());
tot+=b-dfs(i,b,0,num[i]);
}
printf("%I64d\n",tot);
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: